

//stand 23.10.2014  ERMER Christof

/*

NEUE BEFEHLE

formen:
if(!strcasecmp_P( gsCmd.ucaCmd, PSTR("STV")))

uart_puts_p( PSTR("ASURO\r") );

ERROR DETECT
bersprechen der TX DIODE auf IR_RX gefunden.
immer wieder RX Lschen


*/

/* 
BEFEHLE 
22.087.2014

Befelsform:
Kommando,u16Val-1,u16Val-2<13>  <13>  //<13> = CR = \r = 13
Bsp:
Motor,123,34<CR>
Ping<CR>
GetSW>CR>

Diese Datei dient zum einfachen Auffinden und Zufgen der Befehle.
Deshalb wurden die Bfehle in diese Datei ausgelagert.
*/

#include <stdint.h> 
#include <ctype.h>
#include <avr/sfr_defs.h>
#include <avr\io.h>
#include <avr\pgmspace.h> // <--#include <progmem.h>

//#include <stdio.h>
#include <math.h>
#include <stdlib.h>
//#include <stdarg.h>
#include <string.h>
#include <avr\interrupt.h>
#include <avr\wdt.h>
#include <util\delay.h>


//#include "avr_register.h"	//with Hardware assigns
#include "main.h"			//with Hardware assigns
#include "uart.h"
//#include "TxtFunc.h"
#include "statmach.h"
#include "Befehle.h"
#include "debug.h"


/*
EIne Besonderheit des AVR Mikrocontrollers ist die unterschiedliche Behandlung von Zeichen=Strings, 
die entweder im Flash-Speicher  Stehen, und somit von dort gelesen werden,
oder die im RAM stehen,
Es gibt also also C-Funktionen die Strings behandeln doppelt.
einmal mit "Programm Memory Handling" und
quasi Normal: ohne besonderen, dafr RAM-Verbrauchende Stringbehandlung.

Hier liegt musterglitig ein "const cahr" string , d
der aber im "Programm-Flash" abgespeichert wird und nicht im "RAM".
*/

//	\r return
//	\r\n return, line fedd
//	\r\n \t  return, line fedd, tabulator
// GLOBALE VARIABLEN
//CONSTANT ARRAYs IN .TEXT = ROM ARREA   .DATA IST SRAM !! .BSS SRAM
//const char MCA_DELIMTERSTR[] PROGMEM = { ',',0 };
char gcaStr[STRMAX + 1]; //+1 for the 0
char gcaNumStr[NUMMAX + 1]; //+1 for the 0

#ifdef UART_USE_ENABLED
char* gpcRxPars;
char gcaRxStr[RX_STRMAX + 1]; //+1 for the 0
#endif
COMMAND_TYPE gsCmd; // Hier liegen die Befehle und Parameter ab

//Rckgabevariablen
unsigned int u16Value;		// UINT 16 Bit

//CONSTANTEN
const char MCA_TRENNLINIE[] PROGMEM = "-------------\r";
const char MCA_PORTX[] PROGMEM	= " x=B,C,D\r";
//const char MCA_STOP[] PROGMEM	= "Stop mit: SS\r\n";



// *********************************
void CheckOrder(char *pcStrOrder) //von gcaRxStr
// *********************************
{ //Input von der Seriellen Schnittstlle, in der Form:  "BEFEHL,WERT" BSP: "SFR,1000"
//========================
TokensRXStr(pcStrOrder);   //TxtFunc.h
//========================"MS
ResetRxBuff();
 
if( !strcasecmp_P( gsCmd.ucaCmd, PSTR("PING") )  )
	{	
	uart_puts_p( PSTR("PONG\r") );	
	return;
	};


if(!strcasecmp_P( gsCmd.ucaCmd, PSTR("SS"))) //SET Statemachine
	{
	gu8StateMachine = gsCmd.i16CmdVal_1;
	return;
	};

if(!strcasecmp_P( gsCmd.ucaCmd, PSTR("GSS"))) //SET Statemachine
	{
	uart_puts( itoa( gu8StateMachine, gcaStr, 10 ) );	//RAM STRING
	uart_putc( 13 ); //CR
	};




	
if(!strcasecmp_P( gsCmd.ucaCmd, PSTR("SET"))) //0,1 SWITCH EVENT TRAFFIC
	{
	if(gsCmd.i16CmdVal_1)
		{
		gu8TxFlag |=  SW_EVENT_TRAFFIC_ON;
		}
	else
		{
		gu8TxFlag &= ~SW_EVENT_TRAFFIC_ON;
		};
	};	


if(!strcasecmp_P( gsCmd.ucaCmd, PSTR("SW"))) //IR SENS TX ON OFF
	{
	if(gsCmd.i16CmdVal_1)
		{
		gu8TxFlag |= SW_TRAFFIC_ON;
		}
	else
		{
		gu8TxFlag &= ~SW_TRAFFIC_ON;
		};		
	return;
	};

if(!strcasecmp_P( gsCmd.ucaCmd, PSTR("IR"))) //IR SENS TX ON OFF
	{
	if(gsCmd.i16CmdVal_1)
		{
		gu8TxFlag |= IR_TRAFFIC_ON;
		}
	else
		{
		gu8TxFlag &= ~IR_TRAFFIC_ON;
		};		
	return;
	};

	

if(!strcasecmp_P( gsCmd.ucaCmd, PSTR("DEVICE")))  // GET
	{
	uart_puts_p( PSTR("UNO-R3\r") );
	return;
	};




if(!strcasecmp_P( gsCmd.ucaCmd, PSTR("TT"))) //TICKS anzeigen
	{
	uart_puts( ultoa( gu32_Ticks, gcaStr, 10 ) );
	uart_putc( 13 ); //CR
	return;
	};
	
if(!strcasecmp_P( gsCmd.ucaCmd, PSTR("GSM")))	//get State Machine
	{
	uart_puts( itoa( gu8StateMachine, gcaStr, 10 ) );	//RAM STRING
	uart_putc( 13 ); //CR
	return;	
	};


#ifdef ADC_USED_ENABLED	
if( !strcasecmp_P( gsCmd.ucaCmd, PSTR("ADC") )  )    //ADC,0..3
	{	
	uart_puts_p( PSTR("ADC=") );
	uart_puts( itoa( ADC_AT8_10Bit( ADC_5V_AN_C | gsCmd.i16CmdVal_1), gcaStr, 10 ) );
	uart_putc( 13 );
	return;
	};
#endif

if(!strcasecmp_P( gsCmd.ucaCmd, PSTR("BLT")))
	{
	gu32BlinkTime = gsCmd.i16CmdVal_1;
	return;
	};

	
#ifdef DIRECT_PORTUSE_ENABLED
if(!strcasecmp_P( gsCmd.ucaCmd, PSTR("SDDRB")))	//Set DDRB
	{
	lkjkjlasd
	DDRB = gsCmd.i16CmdVal_1 & 0xFF;
	return;
	};
if(!strcasecmp_P( gsCmd.ucaCmd, PSTR("SDDRC")))	//Set DDRC
	{
	DDRC = gsCmd.i16CmdVal_1 & 0xFF;
	return;
	};
if(!strcasecmp_P( gsCmd.ucaCmd, PSTR("SDDRD")))	//Set DDRD
	{
	DDRD = (gsCmd.i16CmdVal_1 & 0xFF) & 0xFE ; //Rx
	return;
	};

if(!strcasecmp_P( gsCmd.ucaCmd, PSTR("GPB")))	//GET PORTB
	{
	uart_puts( ltoa(PINB, gcaStr, 10 ) );
	uart_putc( 13 );
	return;
	};
if(!strcasecmp_P( gsCmd.ucaCmd, PSTR("GPC")))	//GET PORTC
	{
	uart_puts( ltoa(PINC, gcaStr, 10 ) );
	uart_putc( 13 );
	return;
	};
if(!strcasecmp_P( gsCmd.ucaCmd, PSTR("GPD")))	//GET PORTC
	{
	uart_puts( ltoa(PIND, gcaStr, 10 ) );
	uart_putc( 13 );
	return;
	};
	
if(!strcasecmp_P( gsCmd.ucaCmd, PSTR("SPB")))	//SET PORTB
	{
	PORTB = gsCmd.i16CmdVal_1 & 0xFF;
	return;
	};
if(!strcasecmp_P( gsCmd.ucaCmd, PSTR("SPC")))	//SET PORTB
	{
	PORTC = gsCmd.i16CmdVal_1 & 0xFF;
	return;
	};
if(!strcasecmp_P( gsCmd.ucaCmd, PSTR("SPD")))	//SET PORTB
	{
	PORTD = (PORTD & 0x03) | (gsCmd.i16CmdVal_1 & 0xFC);// erhalte RX/TX	
	return;
	};	
#endif //DIRECT_PORTUSE_ENABLED
	
#ifdef MENUE_USED	
if( !strcasecmp_P( gsCmd.ucaCmd, PSTR("??") )  ) //Menue
	{	
	uart_puts_p( PSTR("UNO-R3\r") );	 //\r\n
	uart_puts_p( MCA_TRENNLINIE );	
	uart_puts_p( PSTR("Menue\r") );	 //\r\n
	return;
	};
#endif

if(!strcasecmp_P( gsCmd.ucaCmd, PSTR("SBAUD")))
	{
	uart_init( UART_BAUD_SELECT((uint32_t)gsCmd.i16CmdVal_1, F_CPU) );
	ResetRxBuff();
	return;
	};
/*
if(!strcasecmp_P( gsCmd.ucaCmd, PSTR("")))
	{
	};
*/	
 }; // ORDER



// **************************
void ClearUartRxBuff(void) // neu, 26.08.2014
// **************************
{
while( !(uart_getc() & UART_NO_DATA) ) {wdt_reset();};
};

// **************************
void ResetRxBuff(void)
// **************************
{
ClearUartRxBuff();
gpcRxPars = gcaRxStr; // Set parse pointer back;
*gpcRxPars = 0;	//clear Rx
};

/*
// *******************************************************************
void DisableRx(void)
// *******************************************************************
{
gu8ProgModeFlag |= STOP_UART_RX;
UART0_CONTROL &= ~((1<<RXEN) | (1<<RXCIE));
ResetRxBuff();
};

// *******************************************************************
void EnableTxRx(void)
// *******************************************************************
{
ResetRxBuff();
UART0_CONTROL = (1<<RXCIE)|(1<<RXEN)|(1<<TXEN);
gu8ProgModeFlag &= ~STOP_UART_RX; 
};
*/


#ifdef UART_USE_ENABLED
//Funktionen Definition
// *******************************************************************
void UART_TXRX_Check(void)
/*	
* Get received character from ringbuffer
* uart_getc() returns in the lower byte the received character and
* in the higher byte (bitmask) the last receive error
* UART_NO_DATA is returned when no data is available.
*/
// *******************************************************************
{
uint16_t uiRxUart;
uiRxUart = uart_getc();//!FETCH ALLWAYS BYTE FROM RX RINGBUFF INTERRUPT!
if ( !(uiRxUart & UART_NO_DATA) )  //0x0100
	{
//   * new data available from UART
//  * check for Frame or Overrun error
#ifdef USE_ERROR_MSG
	if ( uiRxUart & (UART_FRAME_ERROR | UART_OVERRUN_ERROR | UART_BUFFER_OVERFLOW) )
		{
		ResetRxBuff();
		uart_init( UART_BAUD_SELECT(UART_BAUD_RATE, F_CPU) );// !! Init UART interface
// Framing Error detected, i.e no stop bit detected
		uart_puts_p(  PSTR("UartErr\r") );
		};
#endif
//NOW SELCT ACTION FROM ORDER
//Check CR
	if(gpcRxPars < (gcaRxStr + RX_STRMAX))	//ENDANSCHLAG ERREICHT ?
		{
		switch( (unsigned  char)uiRxUart  )
			{
			case 10: // LF raus=nix machen
				{				
				break;
				};	           				
			case 13: // order!! from Terminal
				{				
				CheckOrder( gcaRxStr );//gcaRxStr = accumulated str
				//EnableTxRx();
				break;
				};	           				
			default: //Accumulate
				{
      // Accumulate String only to gcaRxStr with uiAAA Parser
				*gpcRxPars++ = (unsigned  char)(uiRxUart & 0x00FF);//Append rxByte
				*gpcRxPars = 0; //ZERO carry
				};
			};//switch
		}
	else  // To much data Rx, than clear simple all
		{
		//overflow of RX clears all
		ResetRxBuff();
		};
// ENDE DER RX EMPFANGSAUSWERTUNG
	};
};

#endif // UART_USE_ENABLED


/* Diese Funktion zerlegt den Befehls-String in einzelne Module */
// *******************************************************************
void TokensRXStr(char *pcStrOrder) //von gcaRxStr
// *******************************************************************
{ //INPUT ERWARTET INDER FOR "BEFEHL,WERT" BSP: "SFR,1000"
//uint16_t uiCnt =0;
const char caDelimiter[]=",";
char * pStrTok; // fr strtok_r
char * pcCh = &pcStrOrder[ strlen(pcStrOrder) ]; // Stelle POINTER auf \0 Ende  // kein unsigned char*

if( (pStrTok = strtok_r( pcStrOrder, caDelimiter , &pcCh)) != NULL) // Trenne 1.Token in Command
	{	
	strcpy(gsCmd.ucaCmd, pStrTok);
	}tt
else
	{
	*gsCmd.ucaCmd = 0;
	};
gsCmd.ucaCmd[ COMAMNDSIZEMAX ] = 0; //Sicherheitsterminierung COMAMNDSIZEMAX=10

//fr 2 fVal Variablen nach dem Kommando
gsCmd.i16CmdVal_1 = 0;
gsCmd.i16CmdVal_2 = 0;
if( (pStrTok = strtok_r( NULL,  caDelimiter, &pcCh)) != NULL)
	{
	//gsCmd.fCmdVal_1 = atof(pStrTok);// Und dann TO Float	
	gsCmd.i16CmdVal_1 = atoi(pStrTok);
	};

if( (pStrTok = strtok_r( NULL,  caDelimiter, &pcCh)) != NULL)
	{
//	gsCmd.fCmdVal_2 = atof(pStrTok);// Und dann TO Float	
	gsCmd.i16CmdVal_2 = atoi(pStrTok);
	};
};



